package PersonFrame;

import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import BMILib.BMICalculator;
import BMILib.BodyMassIndex;
import PersonLib.Activity;
import PersonLib.Gender;
import PersonLib.Person;

public class PersonFrame extends JFrame implements ActionListener, ItemListener, KeyListener {

	JLabel label1 = new JLabel("̸");
	JLabel label2 = new JLabel("");
	JLabel label3 = new JLabel("");
	JLabel label4 = new JLabel("Ű");
	JLabel label5 = new JLabel("");
	JLabel label6 = new JLabel("Ȱ");
	
	JTextField textfield1 = new JTextField(20);
	JTextField textfield2 = new JTextField(20);
	JTextField textfield3 = new JTextField(20);
	JTextField textfield4 = new JTextField(20);
	
	JRadioButton rbutton1 = new JRadioButton("FEMALE", true);
	JRadioButton rbutton2 = new JRadioButton("MALE");
	ButtonGroup rgroup1 = new ButtonGroup();
	JPanel panel1 = new JPanel();
	
	JComboBox<String> combobox1 = new JComboBox<String>(Activity.names());
	Activity selectedActivity = Activity.LOW;
	
	JButton button1 = new JButton("Ȯ");
	
	public PersonFrame(String title) {
		setTitle(title);
		setLayout(null); // layout absolute position ڴٴ 
		
		// label
		label1.setBounds(20, 30, 100, 20);
		label2.setBounds(20, 60, 100, 20);
		label3.setBounds(20, 90, 100, 20);
		label4.setBounds(20, 120, 100, 20);
		label5.setBounds(20, 150, 100, 20);
		label6.setBounds(20, 180, 100, 20);
		add(label1);
		add(label2);
		add(label3);
		add(label4);
		add(label5);
		add(label6);
		
		// textfield
		textfield1.setBounds(120, 30, 150, 20);
		textfield1.addKeyListener(this);
		textfield2.setBounds(120, 60, 150, 20);
		textfield3.setBounds(120, 90, 150, 20);
		textfield4.setBounds(120, 120, 150, 20);
		add(textfield1);
		add(textfield2);
		add(textfield3);
		add(textfield4);
		
		// radiobutton
		panel1.add(rbutton1);
		panel1.add(rbutton2);
		rgroup1.add(rbutton1);
		rgroup1.add(rbutton2);
		panel1.setBounds(120, 150, 150, 30);
		add(panel1);
		
		// combobox
		combobox1.setBounds(120, 180, 150, 20);
		combobox1.addItemListener(this);
		add(combobox1);
		
		// button
		button1.setBounds(60, 220, 160, 20);
		button1.addActionListener(this);
		add(button1);
		
		setSize(300, 300);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
		addWindowListener(new WindowListener() {

			@Override
			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowClosing(WindowEvent e) {
				// TODO Auto-generated method stub
				System.out.println("window close - sort & print personList");
			}

			@Override
			public void windowClosed(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowActivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

		});
	}

	public Gender selectGender() {
		if (rbutton1.isSelected()) {
			return Gender.FEMALE;
		}
		else {
			return Gender.MALE;
		}
	}
	public Activity selectActivity() {
		return Activity.valueOf(combobox1.getSelectedIndex());
	}
	public Person addPerson() {
		Person p = new Person();
		p.setName(textfield1.getText());
		p.setAge(Integer.parseInt(textfield2.getText()));
		p.setWeight(Double.parseDouble(textfield3.getText()));
		p.setHeight(Double.parseDouble(textfield4.getText()));
		p.setGender(selectGender());
		p.setActivity(selectedActivity/*selectActivity()*/);
		System.out.println("Person: " + p);
		return p;
	}
	public void printBMI(Person p) {
		BMICalculator calc = new BMICalculator(p);
		BodyMassIndex bmi = calc.calculateBMI();
		double stdWeight = calc.calculateStandardWeight();
		double dailyIntake = calc.calculateDailyCaloryIntake();
		System.out.println("BMI=" + bmi.toString() 
		+ " ǥü=" + stdWeight + " Ϸ缷뷮=" + dailyIntake);
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		JButton button = (JButton)e.getSource();
		if (button == button1) {
			Person p = addPerson();
			printBMI(p);
		}	
	}

	@Override
	public void itemStateChanged(ItemEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		int selectedIndex = cb.getSelectedIndex();
		switch(selectedIndex) {
		case 0:
			selectedActivity = Activity.LOW;
			break;
		case 1:
			selectedActivity = Activity.MEDIUM;
			break;
		case 2:
			selectedActivity = Activity.HIGH;
			break;
		default:
			break;
		}
	}

	@Override
	public void keyTyped(KeyEvent e) {	
	}

	@Override
	public void keyPressed(KeyEvent e) {
		int key = e.getKeyCode();
		if (key == KeyEvent.VK_ENTER) {
			Toolkit.getDefaultToolkit().beep();
			System.out.println("Enter-key pressed");
			Person p = addPerson();
			printBMI(p);
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {
	}
	
	
	
	
	
	
	
	
	
	
}
